using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using NUnit.Framework;
using  TopCoder.Rules.DependencyMap.View;

namespace TopCoder.Rules.DependencyMap.View.AccuracyTests.Enh5
{
	/// <summary>
	/// Builds different maps and test the layout.
	/// 
    /// @author cucu
    /// Copyright (c)2005, TopCoder, Inc. All rights reserved
    /// </summary>
    [TestFixture]
	public class Enh5
	{
        protected DependencyRenderer renderer = null;
        protected Dependency a = null;
        protected Dependency b = null;
        protected Dependency c = null;
        protected Dependency d = null;
        protected Dependency e = null;
        protected Dependency f = null;
        protected Dependency g = null;

		protected void Start(string test) 
		{
				renderer.AddDiagramRenderer(new SVGRenderer(@"../../test_files/enh5/" + test + "_result.svg"));

		}
        [SetUp]
        protected void SetUp()
        {
            renderer = new DependencyRenderer();

            a = new Dependency("A");
            b = new Dependency("B");
            c = new Dependency("C");
            d = new Dependency("D");
            e = new Dependency("E");
            f = new Dependency("F");
            g = new Dependency("G");

        }

        /// <summary>
        /// Test the sample 1 of the specification
        /// </summary>        
        [Test]
        public void TestSample1()
        {
			Start("TestSample1");
			Dependency h = new Dependency("H");
			Dependency i = new Dependency("I");
			Dependency j = new Dependency("J");
			Dependency k = new Dependency("K");
			Dependency l = new Dependency("L");
			Dependency m = new Dependency("M");
			Dependency n = new Dependency("N");
			Dependency o = new Dependency("O");
			Dependency p = new Dependency("P");

			a.AddDependant(b);
			a.AddDependant(i);
			b.AddDependant(c);
			b.AddDependant(f);
			b.AddDependant(g);
			b.AddDependant(h);
			i.AddDependant(j);
			i.AddDependant(k);
			i.AddDependant(l);
			i.AddDependant(m);
			c.AddDependant(d);
			c.AddDependant(e);
			m.AddDependant(n);
			m.AddDependant(o);
			m.AddDependant(p);
			renderer.Render(a);
		}

        /// <summary>
        /// Test the sample 2 of the specification
        /// </summary>        
        [Test]
		public void TestSample2()
		{
			Start("TestSample2");
			Dependency h = new Dependency("H");
			Dependency i = new Dependency("I");
			Dependency j = new Dependency("J");
			Dependency k = new Dependency("K");

			a.AddDependant(b);
			b.AddDependant(c);
			b.AddDependant(d);
			b.AddDependant(k);
			d.AddDependant(e);
			d.AddDependant(h);
			d.AddDependant(i);
			d.AddDependant(j);
			e.AddDependant(f);
			e.AddDependant(g);
			renderer.Render(a);

		}


	}
}
