/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view.AccuracyTests;

import com.topcoder.rules.dependencymap.view.DiagramRenderer;
import com.topcoder.rules.dependencymap.view.RendererException;

/**
 * Tests for the layout. It generates expected an resulting SVG that must be compared manually.
 *
 * @author cucu
 */
public class LayoutTests extends LayoutAbstractTests {

    protected DiagramRenderer createDiagramRenderer() {
        return new MockDiagramRenderer();
    }

    /**
     * Save the expected and the resulting SVG. Please compare them visually.
     */
    protected void compare(String test, GraphicsHelper gh, DiagramRenderer dr) {
        try {
            // This if should never work, it is here so that I can use the catch for the developer that
            // incorrectly declared that getGraphics throws RendererException
            if (test.equals("this should never happen!")) {
                throw new RendererException("");
            }

            ((MockGraphics)dr.getGraphics(a,1,1)).save("test_files\\" + test + "_result");
            gh.getGraphics().save("test_files\\" + test);
        } catch (RendererException e) {

        }
    }

}
